<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card ">
                    <div class="card-header card-header-success card-header-icon">
                        <div class="card-icon">
                            <i class="fa fa-whatsapp"></i>
                        </div>
                        <h4 class="card-title">{{#whatsappTranslator 'Configuración' lang}}{{/whatsappTranslator}}</h4>
                    </div>
                    <div class="card-body">
                        <form id="formWapp">
                            <div class="form-group">
                                <label for="numero" class="bmd-label-floating">{{#whatsappTranslator 'NúmeroRemitente' lang}}{{/whatsappTranslator}}</label>
                                <input type="text" class="form-control" id="numero" name="numero" required>
                            </div>
                            <div class="form-group">
                                <label for="url_access" class="bmd-label-floating">{{#whatsappTranslator 'URLAPI' lang}}{{/whatsappTranslator}}</label>
                                <input type="text" class="form-control" id="url_access" name="url_access" required>
                            </div>
                            <div class="form-group">
                                <label for="token" class="bmd-label-floating">{{#whatsappTranslator 'Token' lang}}{{/whatsappTranslator}}</label>
                                <input type="text" class="form-control" id="token" name="token" required>
                            </div>

                            <div class="form-group">
                                <label for="tarifa" class="bmd-label-floating">{{#whatsappTranslator 'Tarifa' lang}}{{/whatsappTranslator}}</label>
                                <input type="number" class="form-control" id="tarifa" name="tarifa" step="any" required>
                            </div>
                            <div class="form-group">
                                <button type="submit" class="btn btn-info">
                                    <span class="btn-label"><i class="material-icons">save</i></span>
                                    {{#whatsappTranslator 'Guardar' lang}}{{/whatsappTranslator}}
                                </button>
                                <button type="button" class="btn btn-info" onclick="viewAllTemplates()">
                                    <span class="btn-label"><i class="material-icons">save</i></span>
                                    {{#whatsappTranslator 'ChatBot' lang}}{{/whatsappTranslator}}
                                </button>
                                <i class="mdl-spinner mdl-js-spinner spinnerWapp" style="top:10px;"></i>
                            </div>
                        </form>

                        <div class="table-responsive">
                            <table id="tableWapp" class="table" cellspacing="0" width="100%"
                                style="width:100%">
                                <thead>
                                    <tr>
                                        <th>{{#whatsappTranslator 'ID' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'Remitente' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'URLAPI' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'Token' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'Tarifa' lang}}{{/whatsappTranslator}}</th>
                                        <th class="disabled-sorting text-left">{{#whatsappTranslator 'Acciones' lang}}{{/whatsappTranslator}}</th>
                                    </tr>
                                </thead>
                                <tfoot>
                                    <tr>
                                        <th>{{#whatsappTranslator 'ID' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'Remitente' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'URLAPI' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'Token' lang}}{{/whatsappTranslator}}</th>
                                        <th>{{#whatsappTranslator 'Tarifa' lang}}{{/whatsappTranslator}}</th>
                                        <th class="disabled-sorting text-left">{{#whatsappTranslator 'Acciones' lang}}{{/whatsappTranslator}}</th>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>

                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{{>wapp/modalTemplatesChatBot}}
{{>wapp/modalFlowsChatBot}}
{{>footer}}


<script>

    let idTemplateTemp;

    $(document).ready(function () {
        allTamplates();
        allConnections()
    })

    function updateConnections(tabla){
         let data = {
           id: tabla.find("td:eq(0)").text(),
           numero: tabla.find("td:eq(1)").text(),
           url_access: tabla.find("td:eq(2)").text(),
           token: tabla.find("td:eq(3)").text(),
           tarifa: tabla.find("td:eq(4) #tarifaEdit").val()           
         }

         $.ajax({
             type: 'POST',
             url: '/whatsapp/updateConfig',
             data: data,
             dataType: 'json',
             async: true,
           }).done(function ajaxDone(res) {
             
           })
         


    }

    $('#tableWapp').on('change', 'tr', function () {
      updateConnections($(this))
    });

    $('#tableWapp').on('keyup', 'tr', function () {
      updateConnections($(this))
    });

    $('#tableWapp').on('click', 'tr', function () {
      updateConnections($(this))
    });

    const createdCell = function (cell) {
      let original;
      cell.setAttribute('contenteditable', true)
      cell.setAttribute('spellcheck', false)
      cell.addEventListener("focus", function (e) {
        original = e.target.textContent
      })
    }

    function updateListConnections() {
      var table = $('#tableWapp').DataTable();
      table.ajax.reload();
     } 

    function allConnections(){
        $("#tableWapp").dataTable({
            processing: true,
            ajax: {
                type: "POST",
                url: '/whatsapp/allConnections',
                data: ''
            },
            columnDefs: [
              { className: "hidden", targets:0 },
              { targets: [1, 2, 3], createdCell: createdCell }
            ],
            columns: [
              {'data':'id'},
              {'data':'numero'},
              {'data':'url_access'},
              {'data':'token'},
              {'data':'tarifa', render : function(data, type, row){
                return `<input type="number" class="form-control" id="tarifaEdit" name="tarifaEdit" step="any" value = "${data}" required>`
              }},
              {'data':'id', render: function (data, type, row) {
                    let response = '<div class="form-button-action" style = "display:flex;">'
                                 + '<button class="btn btn-danger btn-round btn-fab"><i class="material-icons" onclick = "deleteConnection(' + data + ')">do_not_disturb_on</i></button></div>';
                    return response;
               }}

            ],
            destroy: true

        })

       
    }

    function deleteConnection(id){
        Swal.fire({
            title: `{{#whatsappTranslator 'EstasSeguroQueDeseasEliminarLaConexión' lang}}{{/whatsappTranslator}}`,
            showDenyButton: true,
            showCancelButton: false,
            confirmButtonText: `{{#whatsappTranslator 'Si' lang}}{{/whatsappTranslator}}`,
            denyButtonText: `{{#whatsappTranslator 'Cancelar' lang}}{{/whatsappTranslator}}`
        }).then((result) => {
            if(result.isConfirmed){
                 $.ajax({
                     type: 'POST',
                     url: '/whatsapp/deleteConfig',
                     data: {id:id},
                     dataType: 'json',
                     async: true,
                 }).done(function ajaxDone(res) {
                     updateListConnections()
                 })          
            }else{

            }
        })

             
        
    }




    $("#formWapp").submit(function (e) {
        e.preventDefault();
        $(".spinnerWapp").addClass("is-active")
        let numero = $("#numero").val();
        let url_access = $("#url_access").val()
        let token = $("#token").val()
        let tarifa = $("#tarifa").val()

        let data = {
            numero: numero,
            url_access: url_access,
            token: token,
            tarifa: tarifa
        }

        $.ajax({
            type: 'POST',
            url: '/whatsapp/addConfig',
            data: data,
            dataType: 'json',
            async: true,
        }).done(function ajaxDone(res) {
            $(".spinnerWapp").removeClass("is-active")
            if (res['status'] == 1) {
                Swal.fire({
                    title: `{{#whatsappTranslator 'Información' lang}}{{/whatsappTranslator}}`,
                    html: `{{#whatsappTranslator 'LaConfiguraciónSeAgregoConExitó' lang}}{{/whatsappTranslator}}`,
                    icon: "info"
                });
                updateListConnections()
            } else {

                Swal.fire({
                    title: `{{#whatsappTranslator 'Alerta' lang}}{{/whatsappTranslator}}`,
                    text: `{{#whatsappTranslator 'HuboUnProblemaAlTratarDeAgregarLaAPI' lang}}{{/whatsappTranslator}}`,
                    icon: "warning"
                });

            }




        }).fail(function ajaxError(e) {
            Swal.fire({
                title: `{{#whatsappTranslator 'AlertaError500' lang}}{{/whatsappTranslator}}`,
                html: `{{#whatsappTranslator 'HuboUnProblemaInternoConsulteASuAdministrador' lang}}{{/whatsappTranslator}}`,
                icon: "error"
            });
            $(".spinnerWapp").removeClass("is-active")
        }).always(function ajaxSiempre() {
            // console.log('Final de la llamada ajax.');
        })

    })

    function viewAllTemplates() {
        $("#modalTemplateschatBot").modal('show')
        allTamplates()
    }

    function updateallTamplates() {
        var table = $('#tableTemplates').DataTable();
        table.ajax.reload();
    }

    $('#tableTemplates').on('change', 'tr', function () {
      editTemplate($(this))
    });

    $('#tableTemplates').on('keyup', 'tr', function () {
       editTemplate($(this))
    });

    $('#tableTemplates').on('click', 'tr', function () {
      editTemplate($(this))
    });

    function editTemplate(tabla) {
      
      //$("#infoFlujos").html("")
      var data = {
         id_template: tabla.find("td:eq(0)").text(),
         descriptionTemplate: tabla.find("td:eq(2) #descriptionEdit").val(),
         blockNumber : tabla.find("td:eq(3) #blockNumberEdit").val()
      }  


      $.ajax({
         type: 'POST',
         url: '/whatsapp/updateTemplate',
         data: data,
         dataType: 'json',
         async: true,
      }).done(function ajaxDone(res) {
         //$("#infoFlujos").html(`<h5>${res['msg_estatus']}</h5>`)


      }).fail(function ajaxError(e) {


      }).always(function ajaxSiempre() {
         // console.log('Final de la llamada ajax.');
      })


   }

    function allTamplates() {
        $("#tableTemplates").dataTable({

            processing: true,
            "language": {
                "url": "//cdn.datatables.net/plug-ins/1.10.15/i18n/Spanish.json"
            },
            ajax: {
                type: "POST",
                url: '/whatsapp/allTemplates',
                data: ''
            },
            columnDefs: [
              { className: "hidden", targets:0 }
            ],
            order: [[0, 'desc']],
            columns: [
                { 'data': 'id_template' },
                { 'data': 'name' },
                { 'data': 'description', render: function (data, type, row) {
                        return `<textarea class="form-control m-b-10" name="descriptionEdit" id="descriptionEdit" rows="4" required="" style = "width: 250px;">${data}</textarea>`
                }},
                {
                    'data': 'block_number', render: function (data, type, row) {
                        if (data == 1) {
                            return `<select class="form-control" id="blockNumberEdit" name="blockNumberEdit">                             
                                 <option value="1">{{#whatsappTranslator 'BloquearAlFinalizar' lang}}{{/whatsappTranslator}}</option>                              
                                 <option value="0">{{#whatsappTranslator 'NoBloquear' lang}}{{/whatsappTranslator}}</option>
                               </select>`
                        } else {
                            return `<select class="form-control" id="blockNumberEdit" name="blockNumberEdit">  
                                 <option value="0">{{#whatsappTranslator 'NoBloquear' lang}}{{/whatsappTranslator}}</option>                           
                                 <option value="1">{{#whatsappTranslator 'BloquearAlFinalizar' lang}}{{/whatsappTranslator}}</option>  
                               </select>`
                        }
                    }
                },
                {
                    'data': 'type', render: function (data, type, row) {
                        if (data == 'msg') {
                            return `<div style="display: flex" bis_skin_checked="1">
                                   <i class="material-icons text-success">quickreply</i>
                                   <span style="margin-left: 10px">{{#whatsappTranslator 'PlantillaSimple' lang}}{{/whatsappTranslator}}</span>
                                </div>`
                        } else {
                            return `<div style="display: flex" bis_skin_checked="1">
                                  <i class="material-icons text-info">smart_toy</i>
                                  <span style="margin-left: 10px">{{#whatsappTranslator 'chatBot1' lang}}{{/whatsappTranslator}}</span>
                                </div>`
                        }
                    }
                },
                {
                    'data': 'id_template', render: function (data, type, row) {
                        if (row.type == 'msg') {
                            return `<div class="form-button-action" style="display:flex;" bis_skin_checked="1">
                                      <button class="btn btn-danger btn-round btn-fab" onclick="deleteChatBotTemplate(${data})"><i class="material-icons">do_not_disturb_on</i></button>
                                 </div>`
                        } else {
                            return `<div class="form-button-action" style="display:flex;" bis_skin_checked="1">
                                     <button class="btn btn-info btn-round btn-fab" onclick="showFlow(${data})"><i class="material-icons">smart_toy</i></button>
                                     <button class="btn btn-danger btn-round btn-fab" onclick="deleteChatBotTemplate(${data})"><i class="material-icons">do_not_disturb_on</i></button>
                                 </div>`
                        }
                    }
                }
            ],
            destroy: true
        })


    }



    $("#formAddTemplate").submit(function (e) {
        e.preventDefault();
        $(".spinnerAddTemplate").addClass("is-active")
        let name = $("#name").val();
        let description = $("#description").val()
        let type = $("#type").val()

        let data = {
            name: name,
            description: description,
            type: type
        }

        $.ajax({
            type: 'POST',
            url: '/whatsapp/addTemplate',
            data: data,
            dataType: 'json',
            async: true,
        }).done(function ajaxDone(res) {
            $(".spinnerAddTemplate").removeClass("is-active")
            if (res['status'] == 1) {
                Swal.fire({
                    title: `{{#whatsappTranslator 'Información' lang}}{{/whatsappTranslator}}`,
                    html: `{{#whatsappTranslator 'LaPlantillaSeAgregoConExitó' lang}}{{/whatsappTranslator}}`,
                    icon: "info"
                });
            } else {

                Swal.fire({
                    title: `{{#whatsappTranslator 'Alerta' lang}}{{/whatsappTranslator}}`,
                    text: `{{#whatsappTranslator 'HuboUnProblemaAlTratarDeAgregarLaPlantilla' lang}}{{/whatsappTranslator}}`,
                    icon: "warning"
                });

            }
            $("#formAddTemplate")[0].reset();
            updateallTamplates()

        }).fail(function ajaxError(e) {
            Swal.fire({
                title: `{{#whatsappTranslator 'AlertaError500' lang}}{{/whatsappTranslator}}`,
                html: `{{#whatsappTranslator 'HuboUnProblemaInternoConsulteASuAdministrador' lang}}{{/whatsappTranslator}}`,
                icon: "error"
            });
            $(".spinnerAddTemplate").removeClass("is-active")
        }).always(function ajaxSiempre() {
            // console.log('Final de la llamada ajax.');
        })

    })


        function deleteChatBotTemplate(id_template) {
        Swal.fire({
            title: `{{#whatsappTranslator 'EstasSeguroQueDeseasEliminarLaPlantilla' lang}}{{/whatsappTranslator}}`,
            showDenyButton: true,
            showCancelButton: false,
            confirmButtonText: `{{#whatsappTranslator 'Si' lang}}{{/whatsappTranslator}}`,
            denyButtonText: `{{#whatsappTranslator 'Cancelar' lang}}{{/whatsappTranslator}}`
        }).then((result) => {

            if (result.isConfirmed) {

                $.ajax({
                    type: 'POST',
                    url: '/whatsapp/daleteTemplate',
                    data: {id_template:id_template},
                    dataType: 'json',
                    async: true,
                }).done(function ajaxDone(res) {

                    if (res['status'] == 1) {
                        Swal.fire({
                            title: `{{#whatsappTranslator 'Exito' lang}}{{/whatsappTranslator}}`,
                            text: `{{#whatsappTranslator 'LaPlantillaSeEliminoCorrectamente' lang}}{{/whatsappTranslator}}`,
                            icon: "success"
                        });
                        // updateListUsers()
                    } else {
                        Swal.fire({
                            title: `{{#whatsappTranslator 'Alerta' lang}}{{/whatsappTranslator}}`,
                            text: `{{#whatsappTranslator 'HuboUnProblemaAlTratarDeEliminarLaPlantilla' lang}}{{/whatsappTranslator}}`,
                            icon: "warning"
                        });
                    }

                    $("#modalTemplateschatBot").modal('hide')

                })

            } else if (result.isDenied) {

            }
        })
    }


    /******************LOGICA DE LOS FLUJOS****************/


    $('#tableFlows').on('change', 'tr', function () {
      editFlow($(this))
    });

    $('#tableFlows').on('keyup', 'tr', function () {
       editFlow($(this))
    });

    $('#tableFlows').on('click', 'tr', function () {
      editFlow($(this))
    });

    function editFlow(tabla) {
      
      //$("#infoFlujos").html("")
      var data = {
         id_flow: tabla.find("td:eq(0)").text(),
         question_one: tabla.find("td:eq(2) #question_one_edit").val(),
         question_two: tabla.find("td:eq(3) #question_two_edit").val(),
         final_message : tabla.find("td:eq(4) #final_message_edit").val()
      }  


      $.ajax({
         type: 'POST',
         url: '/whatsapp/updateFlow',
         data: data,
         dataType: 'json',
         async: true,
      }).done(function ajaxDone(res) {
         //$("#infoFlujos").html(`<h5>${res['msg_estatus']}</h5>`)


      }).fail(function ajaxError(e) {


      }).always(function ajaxSiempre() {
         // console.log('Final de la llamada ajax.');
      })


   }

    function showFlow(id_template) {
        $("#modalFlows").modal('show')
        allFlows(id_template);
        idTemplateTemp = id_template;
    }

    function allFlows(id_template) {
        $("#tableFlows").dataTable({
            processing: true,
            "language": {
                "url": "//cdn.datatables.net/plug-ins/1.10.15/i18n/Spanish.json"
            },
            ajax: {
                type: "POST",
                url: '/whatsapp/allFlows',
                data: { id_template: id_template }
            },
            order: [[0, 'desc']],
            columnDefs: [
              { className: "hidden", targets:0 }
            ],
            columns: [
                { 'data': 'id_flow' },
                { 'data': 'flow' },
                {
                    'data': 'question_one', render: function (data, type, row) {
                        return `<textarea class="form-control m-b-10" name="question_one_edit" id="question_one_edit" rows="4" required="" style = "width: 250px;">${data}</textarea>`
                    }
                },
                {
                    'data': 'question_two', render: function (data, type, row) {
                        return `<textarea class="form-control m-b-10" name="question_two_edit" id="question_two_edit" rows="4" required="" style = "width: 250px;">${data}</textarea>`
                    }
                },
                {
                    'data': 'final_message', render: function (data, type, row) {
                        return `<textarea class="form-control m-b-10" name="final_message_edit" id="final_message_edit" rows="4" required="" style = "width: 250px;">${data}</textarea>`
                    }
                },
                {
                    'data': 'id_flow', render: function (data, type, row) {
                        return `<div class="form-button-action" style="display:flex;" bis_skin_checked="1">
                            <button class="btn btn-danger btn-round btn-fab" onclick="deleteFlow(${data}, ${row.id_template})"><i class="material-icons">do_not_disturb_on</i></button>
                        </div>`
                    }
                }
            ],
            destroy: true

        })

    }



    $("#formAddFlows").submit(function (e) {
        e.preventDefault();
        $(".spinnerAddFlows").addClass("is-active")

        let data = {
            id_template: idTemplateTemp,
            flow: $("#flow").val(),
            question_one: $("#question_one").val(),
            question_two: $("#question_two").val(),
            final_message: $("#final_message").val()
        }



        $.ajax({
            type: 'POST',
            url: '/whatsapp/addFlow',
            data: data,
            dataType: 'json',
            async: true,
        }).done(function ajaxDone(res) {
            $(".spinnerAddFlows").removeClass("is-active")
            if (res['status'] == 1) {
                Swal.fire({
                    title: `{{#whatsappTranslator 'Información' lang}}{{/whatsappTranslator}}`,
                    html: `{{#whatsappTranslator 'LaPlantillaSeAgregoConExitó' lang}}{{/whatsappTranslator}}`,
                    icon: "info"
                });
            } else {

                if (res['msg_estatus'] == 'question_two_null') {

                    Swal.fire({
                        title: `{{#whatsappTranslator 'Alerta' lang}}{{/whatsappTranslator}}`,
                        text: res['msg_response'],
                        icon: "warning"
                    });

                } else {

                    Swal.fire({
                        title: `{{#whatsappTranslator 'Alerta' lang}}{{/whatsappTranslator}}`,
                        text: `{{#whatsappTranslator 'HuboUnProblemaAlTratarDeAgregarLaPlantilla' lang}}{{/whatsappTranslator}}`,
                        icon: "warning"
                    });

                }



            }
             $("#formAddFlows")[0].reset();
             $("#modalFlows").modal('hide')




        }).fail(function ajaxError(e) {
            Swal.fire({
                title: `{{#whatsappTranslator 'AlertaError500' lang}}{{/whatsappTranslator}}`,
                html: `{{#whatsappTranslator 'HuboUnProblemaInternoConsulteASuAdministrador' lang}}{{/whatsappTranslator}}`,
                icon: "error"
            });
            $(".spinnerAddFlows").removeClass("is-active")
        }).always(function ajaxSiempre() {
            // console.log('Final de la llamada ajax.');
        })

    })


    function deleteFlow(id_flow, id_template) {
        Swal.fire({
            title: `{{#whatsappTranslator 'EstasSeguroQueDeseasEliminarElFlujo' lang}}{{/whatsappTranslator}}`,
            showDenyButton: true,
            showCancelButton: false,
            confirmButtonText: `{{#whatsappTranslator 'Si' lang}}{{/whatsappTranslator}}`,
            denyButtonText: `{{#whatsappTranslator 'Cancelar' lang}}{{/whatsappTranslator}}`
        }).then((result) => {

            if (result.isConfirmed) {

                $.ajax({
                    type: 'POST',
                    url: '/whatsapp/daleteFlow',
                    data: {id_flow:id_flow, id_template:id_template},
                    dataType: 'json',
                    async: true,
                }).done(function ajaxDone(res) {

                    if (res['status'] == 1) {
                        Swal.fire({
                            title: `{{#whatsappTranslator 'Exito' lang}}{{/whatsappTranslator}}`,
                            text: `{{#whatsappTranslator 'ElFlujoSeEliminoCorrectamente' lang}}{{/whatsappTranslator}}`,
                            icon: "success"
                        });
                        // updateListUsers()
                    } else {
                        Swal.fire({
                            title: `{{#whatsappTranslator 'Alerta' lang}}{{/whatsappTranslator}}`,
                            text: `{{#whatsappTranslator 'HuboUnProblemaAlTratarDeEliminarElFlujo' lang}}{{/whatsappTranslator}}`,
                            icon: "warning"
                        });
                    }

                    $("#modalFlows").modal('hide')

                })

            } else if (result.isDenied) {

            }
        })
    }







</script>






</body>

</html>